
#ifndef __ComicMaker__h__
#define __ComicMaker__h__

#include "HTTPGet.h"
#include <time.h>
#include <fstream>

class ComicMaker
{
protected:

	struct DATE_TOKEN
	{
		std::string Name;
		int NumDaysAgo;
		std::string Value;
	};

	struct URL_TOKEN
	{
		std::string Name;
		std::string Domain;
		std::string Path;
		std::string ParseToken;
	};

	CListBox* theListbox;
	HTTPGet PageFetcher;

public:
	ComicMaker(CListBox* Listbox);
	~ComicMaker();

	bool Runner(void);

	void ParseWebPage(const std::string &WebPage, std::string SearchString, std::string &ComicID);
	bool ReadInFile(const char *FileToRead, std::string &OutPage);
	void ParseSingleToken(std::string &OutPage, const char* Token, const char* NewVal);
	void ParseTokens(std::string &OutPage, time_t theTime);
	void WriteOutFile(const std::string &OutPage);
	bool GetDateToken(std::ifstream &Reader, DATE_TOKEN &token, char* temp);
	bool GetURLToken(std::ifstream &Reader, URL_TOKEN &token, char* temp);
	bool CheckForUpdates(bool& iniUpdates, bool& progUpdates, bool& updaterUpdate,
		int& iniVersion, int& progVersion, int& UpdateVersion);
	void UpdateTheUpdater(const int iniVersion, const int progVersion, const int UpdateVersion);

	void WriteVersionFile(const int progVersion, const  iniVersion, const  UpdateVersion);

};

#endif