// ComicSetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ComicSetup.h"
#include "ComicSetupDlg.h"
#include <fstream.h>

const char ComicHTMLFile[] = "comic_in.htm";
const char UpdateFileName[] = "update.txt";
const char VersionFileName[] = "version.txt";

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CComicSetupDlg dialog

CComicSetupDlg::CComicSetupDlg(CWnd* pParent /*=NULL*/)
	:	CDialog(CComicSetupDlg::IDD, pParent),
		NumButtons(30)
{
	//{{AFX_DATA_INIT(CComicSetupDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
}

void CComicSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CComicSetupDlg)
	DDX_Control(pDX, IDC_NEXT, m_next);
	DDX_Control(pDX, IDC_PREV, m_prev);
	DDX_Control(pDX, IDC_CHECK9, m_9);
	DDX_Control(pDX, IDC_CHECK8, m_8);
	DDX_Control(pDX, IDC_CHECK7, m_7);
	DDX_Control(pDX, IDC_CHECK6, m_6);
	DDX_Control(pDX, IDC_CHECK5, m_5);
	DDX_Control(pDX, IDC_CHECK4, m_4);
	DDX_Control(pDX, IDC_CHECK30, m_30);
	DDX_Control(pDX, IDC_CHECK3, m_3);
	DDX_Control(pDX, IDC_CHECK29, m_29);
	DDX_Control(pDX, IDC_CHECK28, m_28);
	DDX_Control(pDX, IDC_CHECK27, m_27);
	DDX_Control(pDX, IDC_CHECK26, m_26);
	DDX_Control(pDX, IDC_CHECK25, m_25);
	DDX_Control(pDX, IDC_CHECK24, m_24);
	DDX_Control(pDX, IDC_CHECK23, m_23);
	DDX_Control(pDX, IDC_CHECK22, m_22);
	DDX_Control(pDX, IDC_CHECK21, m_21);
	DDX_Control(pDX, IDC_CHECK20, m_20);
	DDX_Control(pDX, IDC_CHECK2, m_2);
	DDX_Control(pDX, IDC_CHECK19, m_19);
	DDX_Control(pDX, IDC_CHECK18, m_18);
	DDX_Control(pDX, IDC_CHECK16, m_16);
	DDX_Control(pDX, IDC_CHECK17, m_17);
	DDX_Control(pDX, IDC_CHECK15, m_15);
	DDX_Control(pDX, IDC_CHECK14, m_14);
	DDX_Control(pDX, IDC_CHECK13, m_13);
	DDX_Control(pDX, IDC_CHECK12, m_12);
	DDX_Control(pDX, IDC_CHECK11, m_11);
	DDX_Control(pDX, IDC_CHECK10, m_10);
	DDX_Control(pDX, IDC_CHECK1, m_1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CComicSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CComicSetupDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_PREV, OnPrev)
	ON_COMMAND(Unselect_All, OnUnselectAll)
	ON_COMMAND(Check_All, OnCheckAll)
	ON_COMMAND(ComicSort, OnSortComics)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComicSetupDlg message handlers

BOOL CComicSetupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//Set ArraySize to the number of items in the array
	ArraySize = IniFile.ListSize;
	
	CurrentSheet = 0;
	if (ArraySize < NumButtons)
		m_next.EnableWindow(false);

	ButtonArray = (CButton**)malloc((NumButtons)*sizeof(CButton*));

	SetButtonsToStartPosition();

	//Write values to the dialog box
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CComicSetupDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

/*******************************************************/

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CComicSetupDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/*******************************************************/

void CComicSetupDlg::SetButtonsToStartPosition(void)
{
	//Set up the button array to point to the dialog sheet's buttons
	ButtonArray[0] = &m_1;
	ButtonArray[1] = &m_2;
	ButtonArray[2] = &m_3;
	ButtonArray[3] = &m_4;
	ButtonArray[4] = &m_5;
	ButtonArray[5] = &m_6;
	ButtonArray[6] = &m_7;
	ButtonArray[7] = &m_8;
	ButtonArray[8] = &m_9;
	ButtonArray[9] = &m_10;
	ButtonArray[10] = &m_11;
	ButtonArray[11] = &m_12;
	ButtonArray[12] = &m_13;
	ButtonArray[13] = &m_14;
	ButtonArray[14] = &m_15;
	ButtonArray[15] = &m_16;
	ButtonArray[16] = &m_17;
	ButtonArray[17] = &m_18;
	ButtonArray[18] = &m_19;
	ButtonArray[19] = &m_20;
	ButtonArray[20] = &m_21;
	ButtonArray[21] = &m_22;
	ButtonArray[22] = &m_23;
	ButtonArray[23] = &m_24;
	ButtonArray[24] = &m_25;
	ButtonArray[25] = &m_26;
	ButtonArray[26] = &m_27;
	ButtonArray[27] = &m_28;
	ButtonArray[28] = &m_29;
	ButtonArray[29] = &m_30;

	RefillSheet();
	
	return;
}

/*******************************************************/

void CComicSetupDlg::OnCancel() 
{
	CleanUp();
	CDialog::OnCancel();
}

/*******************************************************/

void CComicSetupDlg::OnOK() 
{
	//data from dialog box gets pulled in during the ProcessButtons call, don't
	//need to do it twice.
	ProcessButtons();
	WriteComicFiles();

	CleanUp();
	CDialog::OnOK();
}

/*******************************************************/

void CComicSetupDlg::ProcessButtons(void)
{
	//Pull in values from the dialog box
	UpdateData(TRUE);


	int ComicLoc = CurrentSheet * NumButtons;
	int i = 0;

	while (i < NumButtons)
	{
		if (ComicLoc < ArraySize)
		{
			if (ButtonArray[i]->GetCheck())
			{
				IniFile[ComicLoc]->Subscribed = true;
			}
			else
			{
				IniFile[ComicLoc]->Subscribed = false;
			}
		}
		else
		{
			break;
		}
		i++;
		ComicLoc++;
	};

}

/*******************************************************/

/*
	The goal here is to fill out all the buttons.  All the comics
	are stored in the ComicList array.  That way it's variable,
	I can just add stuff easily there with little effort.
	The user has been scrolling about with Next and Prev, so we
	track that with the CurrentSheet variable.  Using that
	to track into our ComicList array, we just pull out the
	proper items and write them into the ButtonArray,
	which changes the text on the buttons.  That's it.

  Note the ProcessButtons call at the start.  That records the state
  the user left the sheet in before pressing next or prev.
*/
void CComicSetupDlg::RefillSheet(void)
{

	int ComicLoc = CurrentSheet * NumButtons;
	int i = 0;

	while (i < NumButtons)
	{
		if (ComicLoc >= ArraySize)
		{
			ButtonArray[i]->SetWindowText("");
			ButtonArray[i]->SetCheck(0);
		}
		else
		{
			ButtonArray[i]->SetWindowText(IniFile[ComicLoc]->Name.c_str());
			
			if (IniFile[ComicLoc]->Subscribed)
				ButtonArray[i]->SetCheck(1);
			else
				ButtonArray[i]->SetCheck(0);
		}

		i++;
		ComicLoc++;
	};


	//Write values to the dialog box
	UpdateData(FALSE);

	return;
}

/*******************************************************/

//Next And Prev
/*
	These two buttons let the user scroll through the comic
	list.  They just set the CurrentSheet button that tells
	me where we are in the scrolling, and then activate
	and deactivate themselves.  See RefillSheet for the real
	scoop.
*/
void CComicSetupDlg::OnNext() 
{
	ProcessButtons();

	CurrentSheet++;
	if ((CurrentSheet + 1) * NumButtons >= ArraySize)
		m_next.EnableWindow(false);

	m_prev.EnableWindow(true);
	RefillSheet();
}

/*******************************************************/

void CComicSetupDlg::OnPrev() 
{
	ProcessButtons();

	CurrentSheet--;

	if (CurrentSheet == 0)
		m_prev.EnableWindow(false);

	m_next.EnableWindow(true);

	RefillSheet();
}

/*******************************************************/

//Create the comic_out.htm file
void CComicSetupDlg::WriteComicFiles(void)
{
			
//Now create the comic_out.htm file
	ofstream HTMLWriter(ComicHTMLFile);
	if (!HTMLWriter)
	{
		MessageBox("Can't open HTML output file","Error");
		return;
	}

	//Write the headers
	HTMLWriter << "<html><head><title>Comics</title></head><body>" << endl << endl;
	HTMLWriter << "Comic program by <a href=\"mailto:evan@evan.org\">Evan Reynolds.</a>  Please refer to the <a href = \"ReadMe.txt\">ReadMe</a> file for directions on sending me comic requests." << endl << endl;
	for (int i = 0; i < ArraySize; i++)
	{
		if (IniFile[i]->Subscribed)
			HTMLWriter << IniFile[i]->URL.c_str() << endl;
	}
	//Write the end tags
	HTMLWriter << "</body></html>" << endl << endl;

	return;
}

/*******************************************************/

void CComicSetupDlg::CleanUp(void)
{
	free(ButtonArray);
	return;
}

/*******************************************************/

void CComicSetupDlg::OnUnselectAll() 
{
	int i = 0;
	while (i < NumButtons)
	{
		ButtonArray[i++]->SetCheck(0);
	}
		
	for (i = 0; i < ArraySize; i++)
	{
		IniFile[i]->Subscribed = false;
	}

	//Write values to the dialog box
	UpdateData(FALSE);
	
}

/*******************************************************/

void CComicSetupDlg::OnCheckAll() 
{
	int i = 0;
	while (i < NumButtons)
	{
		ButtonArray[i++]->SetCheck(1);
	}
		
	for (i = 0; i < ArraySize; i++)
	{
		IniFile[i]->Subscribed = true;
	}

	//Write values to the dialog box
	UpdateData(FALSE);
	
}

/*******************************************************/

/* 
	After adding comics, which go at the end, it gets hard to find things.
	So I figured a sort function was in order.  This re-orders everything 
	alphabetically.
  */

void CComicSetupDlg::OnSortComics() 
{
	IniFile.SortEntries();
	SetButtonsToStartPosition();

	//Write values to the dialog box
	UpdateData(FALSE);
	return;
}

/*******************************************************/
